package com.kingtom.lightflow;

import com.kingtom.lightflow.engine.FlowEngineConst;
import com.kingtom.kirin.core.common.base.IBaseEnum;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 * 轻流公共常量
 * @author King
 * @since 2024/4/5 17:04
 */
public class LightFlowConst {

    /** 审批流 **/
    public static final String FLOW_Approval = "approval";

    /** 工作流 **/
    public static final String FLOW_Work = "work";

    private LightFlowConst() {}

    public static enum FlowStateEnum implements IBaseEnum<String> {
        Undo("Undo", "未处理"),
        Actived("Actived", "处理进行中"),
        Suspended("Suspended", "处理暂停"),
        Done("Done", "处理完成"),
        Ignored("Ignored", "忽略");

        private String key;

        private String name;

        private FlowStateEnum(String k, String n){
            this.key = k;
            this.name = n;
        }

        @Override
        public String getKey(){
            return key;
        }

        @Override
        public String getName(){
            return name;
        }

        public static FlowEngineConst.FlowStateEnum findEnumByKey(String k){
            return IBaseEnum.findEnumByKey(FlowEngineConst.FlowStateEnum.class, k);
        }
    }

}
