package com.kingtom.lightflow.engine.command;

import cn.hutool.core.util.ObjectUtil;
import com.kingtom.lightflow.engine.model.biz.FlowDef;
import com.kingtom.lightflow.engine.cxt.FlowContext;
import com.kingtom.kirin.core.common.base.Result;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/7/8 14:56
 */
public class AddCommand implements IFlowCommand{

    protected FlowDef flowDef;

    /**
     * 默认不发布
     */
    protected Boolean canPublish = Boolean.FALSE;

    protected Result<String> result;

    public FlowDef getFlowDef() {
        return flowDef;
    }

    public void setFlowDef(FlowDef flowDef) {
        this.flowDef = flowDef;
    }

    public Boolean getCanPublish() {
        return canPublish;
    }

    public void setCanPublish(Boolean canPublish) {
        if(ObjectUtil.isNotNull(canPublish)) {
            this.canPublish = canPublish;
        }
    }

    public Result<String> getResult() {
        return result;
    }

    public void setResult(Result<String> result) {
        this.result = result;
    }

    @Override
    public void execute(FlowContext context) {

    }
}
