package com.kingtom.lightflow.engine.cxt;

import com.kingtom.lightflow.engine.core.FlowEngine;
import com.kingtom.lightflow.engine.ext.IFlowHandler;
import com.kingtom.lightflow.engine.ext.IFlowRoleHandler;
import com.kingtom.lightflow.engine.model.operator.FlowDefOperator;
import com.kingtom.lightflow.engine.model.operator.FlowRunOperator;
import com.kingtom.lightflow.engine.ext.IFlowStorageHandler;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/27 17:21
 */
public class FlowContext {

    /**
     * 数据：流程常量集合
     */
    protected FlowParam flowParam;

    /**
     * 数据：流程定义操作器
     */
    protected FlowDefOperator flowDefOperator;

    /**
     * 数据：流程实例操作器
     */
    protected FlowRunOperator flowRunOperator;

    /**
     * 数据：当前用户
     */
    protected IFlowRoleHandler flowRoleHandler;

    /**
     * 工具：流程处理器
     */
    protected IFlowHandler flowHandler;

    /**
     * 工具：流程存储
     */
    protected IFlowStorageHandler flowStorage;

    /**
     * 工具：引擎
     */
    protected FlowEngine flowEngine;

    public FlowParam getFlowParam() {
        return flowParam;
    }

    public void setFlowParam(FlowParam flowParam) {
        this.flowParam = flowParam;
    }

    public FlowDefOperator getFlowDefOperator() {
        return flowDefOperator;
    }

    public void setFlowDefOperator(FlowDefOperator flowDefOperator) {
        this.flowDefOperator = flowDefOperator;
    }

    public FlowRunOperator getFlowRunOperator() {
        return flowRunOperator;
    }

    public void setFlowRunOperator(FlowRunOperator flowRunOperator) {
        this.flowRunOperator = flowRunOperator;
    }

    public IFlowHandler getFlowHandler() {
        return flowHandler;
    }

    public void setFlowHandler(IFlowHandler flowHandler) {
        this.flowHandler = flowHandler;
    }

    public IFlowStorageHandler getFlowStorage() {
        return flowStorage;
    }

    public void setFlowStorage(IFlowStorageHandler flowStorage) {
        this.flowStorage = flowStorage;
    }

    public IFlowRoleHandler getFlowRoleHandler() {
        return flowRoleHandler;
    }

    public void setFlowRoleHandler(IFlowRoleHandler flowRoleHandler) {
        this.flowRoleHandler = flowRoleHandler;
    }

    public FlowEngine getFlowEngine() {
        return flowEngine;
    }

    public void setFlowEngine(FlowEngine flowEngine) {
        this.flowEngine = flowEngine;
    }
}
