package com.kingtom.lightflow.engine.cxt;

import com.kingtom.kirin.core.common.transfer.Input;
import com.kingtom.kirin.core.common.transfer.normal.MapInput;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/5/8 20:07
 */
public class FlowInput extends MapInput implements Input {

    /**
     * 请求的类型：Action_V_Do=做请求；Action_V_Pre=做请求准备
     */
    public static final String Action_K = "Action";
    public static final String Action_V_Do = "Do";
    public static final String Action_V_Pre = "Pre";

    public static final String DefId_K = "DefId";

    public static final String EntryId_K = "EntryId";

    public static final String TaskId_K = "TaskId";

    public FlowInput() {
        this(Boolean.TRUE);
    }

    public FlowInput(Boolean doAction) {
        super();
        this.findMap().put(Action_K, doAction?Action_V_Do:Action_V_Pre);
    }

    public Boolean findIsActionDo() {
        return Action_V_Do.equals(findParam(Action_K));
    }

    public String findDefId() {
        return findParam(DefId_K);
    }

    public String findEntryId() {
        return findParam(EntryId_K);
    }

    public String findTaskId() {
        return findParam(TaskId_K);
    }

}
