package com.kingtom.lightflow.engine.cxt;

import java.text.MessageFormat;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/27 17:21
 */
public class FlowParam {

    private Map<String,ParamStruct> attr = new LinkedHashMap<>();

    public static final String ATTR_GLOBAL = "global";
    public static final String ATTR_ELEMENT = "e_{0}";
    public static final String ATTR_TMP = "tmp";

    public ParamStruct findGlobalParam() {
        return attr.get(ATTR_GLOBAL);
    }

    public ParamStruct findElementParam(String id) {
        return attr.get(formatKey(id));
    }

    protected ParamStruct findEmpParam() {
        return attr.get(ATTR_TMP);
    }

    protected String formatKey(String id) {
        return MessageFormat.format(ATTR_ELEMENT,id);
    }

}
