package com.kingtom.lightflow.engine.cxt;

import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/1/16 15:01
 */
public class ParamStruct {

    protected Map<String,Object> attr = new LinkedHashMap<>();

    @JsonAnyGetter
    public Map<String, Object> getAttr() {
        return attr;
    }

    public void setAttr(Map<String, Object> attr) {
        this.attr.clear();
        if(attr != null) {
            this.attr.putAll(attr);
        }
    }

    @JsonAnySetter
    public void addAttr(String k, Object o) {
        this.attr.put(k,o);
    }

    public <T> T findAttr(String k) {
        return (T)this.attr.get(k);
    }
}
