package com.kingtom.lightflow.engine.ext;

import com.kingtom.lightflow.engine.cxt.FlowContext;
import com.kingtom.kirin.core.common.transfer.Input;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/26 17:28
 */
public interface IFlowConnectHandler {

    /**
     *  申明自己能够处理的类型
     * @return 返回自己能够处理的类型
     */
    String defineType();

    /**
     * 连接的处理
     * @param context 流程上下文
     * @param input 输入
     * @return 下一步code
     */
    String doConnect(FlowContext context, Input input);

}
