package com.kingtom.lightflow.engine.ext;

import com.kingtom.lightflow.engine.cxt.FlowContext;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/1/23 16:40
 */
public interface IFlowHandler {

    /**
     * 申明自己针对的流程类型
     * @return
     */
    String defineName();

    /**
     * 按照本流程类型填充FlowContext
     * @param context
     */
    void fillFlowContext(FlowContext context);

    /**
     * 查找节点处理器
     * @param objectType
     * @return
     */
    IFlowObjectHandler findFlowObjectHandler(String objectType);

    /**
     * 查找连接处理器
     * @param connectType
     * @return
     */
    IFlowConnectHandler findFlowConnectHandler(String connectType);

}
