package com.kingtom.lightflow.engine.ext;

import com.kingtom.lightflow.engine.cxt.FlowContext;
import com.kingtom.lightflow.engine.cxt.FlowInput;
import com.kingtom.lightflow.engine.cxt.FlowOutput;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/26 17:27
 */
public interface IFlowObjectHandler {

    /**
     *  申明自己能够处理的类型
     * @return 自己能够处理的类型
     */
    String defineType();

    /**
     * 节点进入时
     * @param context 流程上下文
     * @param input 输入
     * @param output 输出
     */
    void doIn(FlowContext context, FlowInput input, FlowOutput output);

    /**
     * 节点处理
     * @param context 流程上下文
     * @param input 输入
     * @param output 输出
     */
    void doProcess(FlowContext context, FlowInput input, FlowOutput output);

    /**
     * 节点退出时
     * @param context 流程上下文
     * @param input 输入
     * @param output 输出
     */
    void doOut(FlowContext context, FlowInput input, FlowOutput output);

}
