package com.kingtom.lightflow.engine.model.biz;

import cn.hutool.core.collection.ListUtil;
import com.kingtom.lightflow.engine.model.bean.FlowDefConnect;
import com.kingtom.lightflow.engine.model.bean.FlowDefInfo;
import com.kingtom.lightflow.engine.model.bean.FlowDefNode;
import com.kingtom.lightflow.engine.model.bean.FlowDefVar;
import com.kingtom.kirin.core.common.utils.JsonUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 * 流程定义对象
 * @author King
 * @since 2023/12/22 16:30
 */
public class FlowDef {

    protected FlowDefInfo info;
    protected List<FlowDefVar> confs = new ArrayList<>();
    protected List<FlowDefNode> objects = new ArrayList<>();
    protected List<FlowDefConnect> connects = new ArrayList<>();

    public FlowDefInfo getInfo() {
        return info;
    }

    public void setInfo(FlowDefInfo info) {
        this.info = info;
    }

    public List<FlowDefVar> getConfs() {
        return confs;
    }

    public void setConfs(List<FlowDefVar> confs) {
        this.confs.clear();
        if(confs != null) {
            this.confs.addAll(JsonUtils.toObjectTypeList(confs, ListUtil.toList(), FlowDefVar.class));
        }
    }

    public List<FlowDefNode> getObjects() {
        return objects;
    }

    public void setObjects(List<FlowDefNode> objects) {
        this.objects.clear();
        if(objects != null) {
            this.objects.addAll(JsonUtils.toObjectTypeList(objects, ListUtil.toList(), FlowDefNode.class));
        }
    }

    public List<FlowDefConnect> getConnects() {
        return connects;
    }

    public void setConnects(List<FlowDefConnect> connects) {
        this.connects.clear();
        if(connects != null) {
            this.connects.addAll(JsonUtils.toObjectTypeList(connects, ListUtil.toList(), FlowDefConnect.class));
        }
    }
}
