package com.kingtom.lightflow.engine.model.operator;

import com.kingtom.lightflow.engine.FlowEngineConst;
import com.kingtom.lightflow.engine.model.bean.FlowDefConnect;
import com.kingtom.lightflow.engine.model.biz.FlowDef;
import com.kingtom.lightflow.engine.model.bean.FlowDefInfo;
import com.kingtom.lightflow.engine.model.bean.FlowDefNode;
import com.kingtom.lightflow.engine.utils.FlowEngineUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/26 17:36
 */
public class FlowDefOperator {

    protected FlowDef flowDef;

    public FlowDefOperator(FlowDef def) {
        this.flowDef = def;
    }

    public String toJson() {
        return FlowEngineUtils.parseJson(flowDef);
    }

    /*** 流程定义查询类接口 **/
    public FlowDefInfo findFlowInfoDef() {
        return flowDef.getInfo();
    }

    public FlowDefNode findFlowObjectOfStart() {
        return findFlowObject(FlowEngineConst.Flow_event_start);
    }

    public FlowDefNode findFlowObject(String code) {
        return flowDef.getObjects().stream().filter(o->code.equals(o.getCode())).findFirst().orElse(null);
    }

    public FlowDefConnect findFlowConnect(String code) {
        return flowDef.getConnects().stream().filter(o->code.equals(o.getCode())).findFirst().orElse(null);
    }

    public List<FlowDefConnect> findFlowConnectsOfNext(FlowDefNode odef) {
        List<FlowDefConnect> r = new ArrayList<>();
        String code = odef.getCode();
        for(FlowDefConnect connectDef : flowDef.getConnects()) {
            if(connectDef.getSrcNode().equals(code)) {
                r.add(connectDef);
            }
        }
        return r;
    }

    /*** 流程定义修改类接口 **/

    public void clearModify() {
    }

    public boolean isModify() {
        return true;
    }

}
