package com.kingtom.lightflow.engine.utils;

import com.kingtom.lightflow.engine.model.bean.FlowDefConnect;
import com.kingtom.lightflow.engine.model.bean.FlowDefInfo;
import com.kingtom.lightflow.engine.model.bean.FlowDefNode;
import com.kingtom.lightflow.engine.model.bean.FlowDefVar;
import com.kingtom.lightflow.engine.model.biz.FlowDef;
import org.mapstruct.Mapper;
import org.mapstruct.factory.Mappers;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/2/27 16:40
 */
@Mapper
public interface FlowEngineMapper {

    public static final FlowEngineMapper INSTANCT = Mappers.getMapper(FlowEngineMapper.class);

    default FlowDef convert(FlowDef bean) {
        FlowDef r = new FlowDef();
        r.setInfo(convert(bean.getInfo()));
        for(FlowDefNode objectDef: bean.getObjects()) {
            r.getObjects().add(convert(objectDef));
        }
        for(FlowDefConnect connectDef: bean.getConnects()) {
            r.getConnects().add(convert(connectDef));
        }
        for(FlowDefVar confDef: bean.getConfs()) {
            r.getConfs().add(convert(confDef));
        }
        return r;
    }

    FlowDefInfo convert(FlowDefInfo bean);

    FlowDefNode convert(FlowDefNode bean);

    FlowDefConnect convert(FlowDefConnect bean);

    FlowDefVar convert(FlowDefVar bean);
}
