package com.kingtom.lightflow.engine.utils;

import com.kingtom.lightflow.engine.model.biz.FlowDef;
import com.kingtom.lightflow.engine.model.operator.FlowDefOperator;
import com.kingtom.kirin.core.common.exception.AppException;
import com.kingtom.kirin.core.common.utils.JsonUtils;

/**
 * <p>
 * Copyright: Copyright (C) 2023 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2023/12/26 17:31
 */
public class FlowEngineUtils {

    private FlowEngineUtils(){}

    public static FlowDef copyBean(FlowDef bean) {
        return FlowEngineMapper.INSTANCT.convert(bean);
    }

    public static FlowDefOperator pareseDefOperator(String flowJson){
        FlowDef def = parseDef(flowJson);
        return new FlowDefOperator(def);
    }

    public static FlowDefOperator pareseDefOperator(FlowDef flowDef){
        return new FlowDefOperator(flowDef);
    }

    public static FlowDef parseDef(String flowDefJson) {
        try{
            return JsonUtils.toObject(flowDefJson, FlowDef.class);
        } catch (Exception e) {
            throw new AppException("解析流程JSON错误",e);
        }
    }

    public static String parseJson(FlowDef flowDef) {
        return JsonUtils.toJson(flowDef);
    }
}
