package com.kingtom.lightflow.engineimpl.service;

import com.kingtom.lightflow.engine.model.biz.FlowDef;
import com.kingtom.lightflow.engine.command.AddCommand;
import com.kingtom.lightflow.engine.command.CheckCommand;
import com.kingtom.lightflow.engine.command.PublishCommand;
import com.kingtom.lightflow.engine.command.SaveCommand;
import com.kingtom.lightflow.engine.core.FlowEngine;
import com.kingtom.kirin.core.common.base.Result;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/7/8 17:52
 */
public class FlowDesignServiceImpl implements IFlowDesignService{

    protected FlowEngine flowEngine;

    @Override
    public Result<Boolean> doCheck(FlowDef flowDef) {
        CheckCommand c = new CheckCommand();
        c.setParamFlowDef(flowDef);
        flowEngine.executeCommand(c);
        return c.getResult();
    }

    @Override
    public Result<String> doAdd(FlowDef flowDef, Boolean doPublish) {
        AddCommand c = new AddCommand();
        c.setFlowDef(flowDef);
        c.setCanPublish(doPublish);
        flowEngine.executeCommand(c);
        return c.getResult();
    }

    @Override
    public Result<Boolean> doPublish(String defId) {
        PublishCommand c = new PublishCommand();
        c.setFlowDefId(defId);
        flowEngine.executeCommand(c);
        return c.getResult();
    }

    @Override
    public Result<Boolean> doSave(String defId, FlowDef flowDef, Boolean doPublish) {
        SaveCommand c = new SaveCommand();
        c.setFlowDef(flowDef);
        c.setFlowDefId(defId);
        c.setCanPublish(doPublish);
        flowEngine.executeCommand(c);
        return c.getResult();
    }
}
