package com.kingtom.lightflow.engineimpl.service;

import com.kingtom.lightflow.engine.model.biz.FlowDef;
import com.kingtom.kirin.core.common.base.Result;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/5/8 15:03
 */
public interface IFlowDesignService {

    /**
     * 检查流程定义
     * @param flowDef 流程定义
     * @return 检查结果（尽量不抛出异常，用结果返回）
     */
    Result<Boolean> doCheck(FlowDef flowDef);

    /**
     * 新增流程
     * @param flowDef 流程定义
     * @param doPublish 发布
     * @return 流程ID
     */
    Result<String> doAdd(FlowDef flowDef, Boolean doPublish);

    /**
     * 发布流程
     * @param defId 流程ID
     * @return 流程ID
     */
    Result<Boolean> doPublish(String defId);

    /**
     * 修改并保存已存在的流程定义
     * @param defId 流程ID
     * @param flowDef 流程定义
     * @param doPublish 是否发布
     * @return 流程ID
     */
    Result<Boolean> doSave(String defId, FlowDef flowDef, Boolean doPublish);

}
