package com.kingtom.lightflow.engineimpl.service;

import com.kingtom.lightflow.engine.cxt.FlowOutput;
import com.kingtom.kirin.core.common.transfer.Input;
import com.kingtom.kirin.core.common.transfer.Output;

/**
 * <p>
 * Copyright: Copyright (C) 2024 KingTom, Inc. All rights reserved. <p>
 * Company: 成都诚唐科技有限公司<p>
 *
 * @author King
 * @since 2024/5/8 15:04
 */
public interface IFlowRunService {

    /**
     * 启动一个流程实例
     * @param defId 流程定义ID
     * @param input 参数集合
     * @param output 结果反馈
     */
    FlowOutput doStart(String defId, Input input, Output output);

    /**
     * 停止一个流程实例
     * @param entryId 流程实例ID
     * @param input 参数集合
     * @param output 结果反馈
     */
    FlowOutput doStop(String entryId, Input input, Output output);

    /**
     * 暂停一个流程实例
     * @param entryId 流程实例ID
     * @param input 参数集合
     * @param output 结果反馈
     */
    FlowOutput doPause(String entryId, Input input, Output output);

    /**
     * 处理流程任务
     * @param taskId 流程任务ID
     * @param input 参数集合
     * @param output 结果反馈
     */
    FlowOutput doTask(String taskId, Input input, Output output);

}
